#!/usr/bin/python

import gtk
import control

class Preferences_UI:
    def __init__(self):
        control.__init__()
        self.ui = gtk.Builder()
        self.ui.add_from_file(control.controller.PREFERENCES_UI)
        self.window = self.ui.get_object("window1")
        self.window.connect("destroy", self.hide_window)
        self.window.set_position(gtk.WIN_POS_CENTER)
        self.window.set_title("Lubuntu Software Center Preferences")
        self.combo = self.ui.get_object("combobox1")
        self.cancel = self.ui.get_object("cancel_button")
        self.cancel.connect("clicked", self.hide_window)
        self.apply = self.ui.get_object("apply_button")
        self.apply.connect("clicked", self.apply_preferences)
        self.refresh_func = None
        if not control.controller.expert_mode:
            self.combo.set_active(0)
        elif control.controller.expert_mode:
            self.combo.set_active(1)
    
    def hide_window(self, widget):
        self.window.hide()
    
    def show(self):
        self.window.show_all()
    
    def apply_preferences(self, widget):
        control.controller.conf_file.write("")
        control.controller.conf_file.close()
        control.controller.conf_file = open(control.controller.file_path, "w")
        if self.combo.get_active() == 0:
            control.controller.parser.set("General", "expert_mode", "FALSE")
            control.controller.parser.write(control.controller.conf_file)
            control.controller.conf_file.close()
        elif self.combo.get_active() == 1:
            control.controller.parser.set("General", "expert_mode", "TRUE")
            control.controller.parser.write(control.controller.conf_file)
            control.controller.conf_file.close()
        self.hide_window(None)
        self.refresh_func()
        
