#!/usr/bin/python

import gtk
import pango

class Entry(gtk.ToolItem):
    def __init__(self):
        super(Entry, self).__init__()
        self.search_function = None
        self.search_font = pango.FontDescription("italic")
        self.normal_font = pango.FontDescription("normal")
        self.search_entry = gtk.Entry()
        self.search_entry.set_text("Search a package...")
        self.search_entry.modify_font(self.search_font)
        self.search_entry.set_icon_from_stock(0, gtk.STOCK_FIND)
        self.search_string = "Search a package..."
        self.add(self.search_entry)
        self.search_entry.connect("focus-out-event", self.on_focus_out)
        self.search_entry.connect("focus-in-event", self.on_focus_in)
        self.search_entry.connect("key-release-event", self.on_inserting_text)
        self.search_entry.connect("icon-press", self.on_press_icon)
    
    def on_focus_out(self, widget, event):
        if widget.get_text() == "":
            widget.set_text(self.search_string)
            widget.modify_font(self.search_font)
    
    def on_focus_in(self, widget, event):
        if widget.get_text() == self.search_string:
            widget.set_text("")
        widget.modify_font(self.normal_font)
    
    def on_inserting_text(self, widget, event):
        string = widget.get_text()
        if not string == "":
            widget.set_icon_from_stock(1, gtk.STOCK_CLEAR)
        else:
            widget.set_icon_from_stock(1, None)
        if self.search_function != None:
            self.search_function(string)
    
    def on_press_icon(self, widget, position, event):
        if position == 1:
            widget.set_text("")
            widget.set_icon_from_stock(1, None)  
            self.search_function("")  
