#!/usr/bin/python

import gtk
import control
import os
from xdg import DesktopEntry as DE
import threading

gtk.gdk.threads_init()

class refresh_system(threading.Thread):
    def __init__(self, app):
        super(refresh_system, self).__init__()
        control.__init__()
        self.app = app
    def run(self):
        x = 0
        self.app.ui.paned.set_sensitive(False)
        if not control.controller.expert_mode:
            self.aiddir = os.listdir(self.app.aid)
            for item in self.aiddir:
                if item.partition(".desktop")[-2] == ".desktop":
                    self.single_pkg = DE.DesktopEntry(self.app.aid+item)
                    x += 1
                    self.app.define_packages(
                    self.single_pkg.getName(),
                    self.single_pkg.get("X-AppInstall-Package"),
                    self.single_pkg.getIcon(),
                    self.single_pkg.getCategories(),
                    (x, len(self.aiddir))
                    )
                else:
                    x += 1
        else:
            for item in self.app.cache.packages:
                x += 1
                self.app.define_packages(item.name,
                item.name,
                None,
                item.section.replace("universe/", "").replace("multiverse/", ""),
                (x, len(self.app.cache.packages))
                )
        self.app.ui.progressbar.set_fraction(0)
        self.app.ui.paned.set_sensitive(True)

class append_packages(threading.Thread):
    def __init__(self, app, category, status, model):
        super(append_packages, self).__init__()
        control.__init__()
        self.app = app
        self.category = category
        self.status = status
        self.model = model
    
    def run(self):
        self.status_dict = {
        0: None,
        1: None,
        2: None,
        4: None,
        5: None,
        6: gtk.STOCK_YES
        }
        x = 0
        if self.category == "all":
            for items in self.app.packages:
                try:
                    x += 1
                    self.app.append_packages_appending(items, self.status, self.status_dict, self.model, (x, len(self.app.packages)))
                except KeyError: pass
        else:
            for items in self.app.packages:
                try:
                    if self.category in items[3]:
                        x += 1
                        self.app.append_packages_appending(items, self.status, self.status_dict, self.model, (x, len(self.app.packages)))
                except KeyError: pass
        self.app.ui.progressbar.set_fraction(0)
        self.app.ui.installed_count.set_text("%s packages listed" % len(self.app.ui.installed_model))
        self.app.ui.pkgs_count.set_text("%s packages listed" % len(self.app.ui.apps_model))
        self.app.ui.paned.set_sensitive(True)
        self.app.ui.search_pkg.set_sensitive(True)
        if self.app.ui.search_pkg.search_entry.get_text() != self.app.ui.search_pkg.search_string:
            self.app.ui.search_pkg.search_function(self.app.ui.search_pkg.search_entry.get_text())
