#!/usr/bin/python

from aptdaemon import client, gtkwidgets
import sys
import gtk

def finish(transaction, exit_status):
    if exit_status == "exit-success":
        dialog.hide()
        print("succes")
        sys.exit(0)
    else:
        dialog.hide()
        finishdialog = gtkwidgets.AptErrorDialog(error=transaction.error)
        finishdialog.run()
        print("failed")
        sys.exit(0)

if len(sys.argv) == 3:
    client = client.AptClient()
    box = gtk.VBox(False, 10)
    box.set_border_width(10)
    hbox = gtk.HBox(False, 10)
    status = gtkwidgets.AptStatusLabel()
    statusicon = gtkwidgets.AptStatusIcon()
    details = gtkwidgets.AptDetailsExpander()
    hbox.pack_start(statusicon, False)
    hbox.pack_start(status, False)
    progress = gtkwidgets.AptProgressBar()
    box.pack_start(hbox, False)
    box.pack_start(progress,True, False)
    box.pack_start(details, False)
    dialog = gtk.Window()
    dialog.set_position(gtk.WIN_POS_CENTER)
    dialog.set_size_request(400, 130)
    dialog.add(box)
    
    pkgs = sys.argv[2].split(",")
    if sys.argv[1] == 'install':
        transaction = client.install_packages(pkgs)
        transaction.connect("finished", finish)
        status.set_transaction(transaction)
        statusicon.set_transaction(transaction)
        progress.set_transaction(transaction)
        details.set_transaction(transaction)
        try:
            dialog.show_all()
            transaction.run()
        except:
            print("aborted")
            sys.exit(0)
    
    elif sys.argv[1] == 'remove':
        transaction_remove = client.remove_packages(pkgs)
        transaction_remove.connect("finished", finish)
        status.set_transaction(transaction_remove)
        statusicon.set_transaction(transaction_remove)
        progress.set_transaction(transaction_remove)
        details.set_transaction(transaction_remove)
        try:
            dialog.show_all()
            transaction_remove.run()
        except:
            print("aborted")
            sys.exit(0)
    else:
        print("%s is an invalid method" % sys.argv[1])
        sys.exit(0)

gtk.main()
